variables:
  REGISTRY_IMAGE: ""
  DOCKER_HOST: tcp://docker:2375
  DOCKER_TLS_CERTDIR: ""
  BUILD_DIR: "."

stages:
- build

.build:
  stage: build
  image: luktom/ws
  services:
  - docker:dind
  script:
  - |
    if [[ -z "$VERSION" ]]; then
      echo "Generating version"
      VERSION=v$(date "+%Y%m%d%H%M%S")
      echo "$VERSION" > version
      echo "Using version $VERSION"
    fi

    if [[ ! -z "$DOCKERFILE_TEMPLATE" ]]; then
      echo "Downloading Dockerfile template $DOCKERFILE_template"
      curl -s -o Dockerfile https://gitlab.com/luktom/ci/-/raw/master/dockerfiles/$DOCKERFILE_TEMPLATE.dockerfile
    fi

    if [[ ! -z "$DOCKER_AUTH_CMD" ]]; then
      echo "Evaluating docker auth command"
      eval "$DOCKER_AUTH_CMD"
    fi

    docker build --build-arg BUILD_DIR=$BUILD_DIR -t $REGISTRY_IMAGE -t $REGISTRY_IMAGE:$VERSION .
    docker push $REGISTRY_IMAGE
    docker push $REGISTRY_IMAGE:$VERSION
  artifacts:
    paths:
    - version
  only:
    - master
